# Build Guide for Keyball46

こちらは Keyball46 のビルドガイドになります。

 - [English Build Guide is here](https://github.com/Yowkees/keyball/blob/main/keyball46/doc/rev1/buildguide_en.md)
  

![01](images/yw001.jpg)

## 【目次】

  - [１．部品確認](#１部品確認)
    - [1-1．キット同梱品](#1-1キット同梱品)
    - [1-2．組立前にお客様自身で準備いただく部品](#1-2組立前にお客様自身で準備いただく部品)
    - [1-3．組立後でも取り付けられる部品とオプション](#1-3組立後でも取り付けられる部品とオプション)
  - [２．準備](#２準備)
    - [2-1．必要な工具](#2-1必要な工具)
    - [2-2．ファームウェア](#2-2ファームウェア)
  - [３．実装](#３実装)
    - [3-1．はんだ付けの前に](#3-1はんだ付けの前に)
    - [3-2．ダイオードの取り付け](#3-2ダイオードの取り付け)
    - [3-3．ジャンパのはんだ付け](#3-3ジャンパのはんだ付け)
    - [3-4．4連ピンソケット・TRRSソケット・タクトスイッチ](#3-44連ピンソケットtrrsソケットタクトスイッチ)
    - [3-5．ProMicroのはんだ付け](#3-5promicroのはんだ付け)
    - [3-6．ProMicoの書き込みと動作確認](#3-6promicoの書き込みと動作確認)
    - [3-7．アンダーグロー用LED（オプション）のはんだ付け](#3-7アンダーグロー用ledオプションのはんだ付け)
    - [3-8．キーソケットのはんだ付け](#3-8キーソケットのはんだ付け)
  - [４．ボール読み取り基板の組み立て](#４ボール読み取り基板の組み立て)
  - [4-1．センサーのはんだ付け](#4-1センサーのはんだ付け)
    - [4-2．L字コンスルーのはんだ付け](#4-2l字コンスルーのはんだ付け)
  - [５．左手側の左右判定ジャンパーをはんだ付け](#５左手側の左右判定ジャンパーをはんだ付け)
  - [６．トッププレートのカット（オプション）](#６トッププレートのカットオプション)
  - [７．組み立て](#７組み立て)
    - [7-1.保護プレートの取り付け](#7-1保護プレートの取り付け)
    - [7-2.トッププレートの組み立て](#7-2トッププレートの組み立て)
    - [7-3.ボトムプレートの組み立て](#7-3ボトムプレートの組み立て)
  - [８．トラックボール取り付け](#８トラックボール取り付け)
    - [8-1.ボール読み取り基板差し込み](#8-1ボール読み取り基板差し込み)
    - [8-2.トラックボールケースの組み立て](#8-2トラックボールケースの組み立て)
    - [8-3.トラックボールケース装着](#8-3トラックボールケース装着)
  - [９．総仕上げ](#９総仕上げ)
  - [１０．正規ファームウェアの書き込み](#１０正規ファームウェアの書き込み)
  - [１１．Keyballの使い方♪](#１１keyballの使い方)

<a id="anchor1"></a>
## １．部品確認

キットが届きましたらキット同梱品がすべて入っていたかご確認ください。

<a id="anchor1-1"></a>
### 1-1．キット同梱品

| 名前 | 数 | 備考 |
|:-|:-|:-|
| PCB(左右) | １組 | |
| トップPCBプレート(左右) | １組 | |
| ボトムアクリルプレート(左右) | １組 | |
| ProMicro保護プレート(左右) | １組 | |
| トラックボール保持ケース白(上下) | １組 | |
| Φ2 セラミックボール | ５個 | （予備２個） |
| トラックボール読取り基板 | １枚 | |
| L字コンスルーピン(7ピン) | １個 | |
| トラックボール読取りIC | １個 | |
| 読取りIC用レンズ | １個 | |
| 平頭ネジ M1.7 | ２本 | |
| 小頭ネジ M1.7 | ２本 | |
| TRRSジャック | ２個 | |
| タクトスイッチ | ２個 | |
| ダイオード（チップタイプ） | ５２個＋ | リードタイプにも対応(オプション) |
| Kailh PCBソケット | ５０個 | |
| OLEDモジュール | １枚 | |
| 4連ピンヘッダ  | ２つ | |
| 4連ピンソケット | ２つ | |
| スペーサー M2 7mm | １５本 | |
| スペーサー M2 9mm | ５本 | |
| ネジ M2 3.5mm | ３８本＋ | |
| クッションゴム | ８個 | |

![02](images/yw002.jpg)

<a id="anchor1-2"></a>
### 1-2．組立前にお客様自身で準備いただく部品

| 名前 | 数 | 備考 |
|:-|:-|:-|
| ProMicro | ２個 | 安価なものやUSB Type-C対応のもの等選べます |
| キースイッチ | ４６個 | CherryMX互換のもの |
| 直径34mmトラックボール | １個 | 動作確認で使用します |
| TRS(3極)ケーブル | １本 | TRRS(4極)ケーブルでも可 |
| Micro USBケーブル | １本 | ご購入いただいたProMicroに対応するもの |

![03](images/yw003.jpg)

<a id="anchor1-3"></a>
### 1-3．組立後でも取り付けられる部品とオプション

| 名前 | 数 | 備考 |
|:-|:-|:-|
| キーキャップ | ４６個 | 1u ４５個、1.25u １個 |
| YS-SK6812MINI-E | １４個 | アンダーグロー用　※SK6812MINIは使用できません |

![04](images/yw004.jpg)

<a id="anchor2"></a>
## ２．準備

<a id="anchor2-1"></a>
### 2-1．必要な工具

Keyball46の組み立てには下記の工具が必要です。

| 名前 |
|:-|
| はんだごて(LEDを実装する場合は温度調整可能なもの) |
| はんだ(LEDを実装する場合は低融点のものが有効) |
| ニッパー |
| ０番＋精密ドライバー |
| ピンセット |

![05](images/yw005.jpg)

<a id="anchor2-2"></a>
### 2-2．ファームウェア

Keyball46を動作させるには、ご購入いただいたProMicroへのファームウェアの書き込みが必要です。
すでにビルド済みのファームウェアがダウンロードできますので、ProMicroへの書き込みソフト『QMK Toolbox』だけ準備できればKeyball46を使用できます。QMK Toolboxについては [Corneのファームウェア](https://github.com/foostan/crkbd/blob/master/doc/firmware_jp.md) の記事に簡潔にまとめられていますのでリンク先前半の説明を読んでQMK Toolboxを準備しておいてください。  

書き込みについてはこの後の[3-6章](#3-6promicoの書き込みと動作確認)でテスト用のファームウェアの書き込み、[１０章](#１０正規ファームウェアの書き込み)で製品版ファームウェアの書き込みについて詳しく説明しています。

<a id="anchor4"></a>
## ３．実装

ここからはんだ付け作業に入ります。  
PCBはリバーシブルになっているので、最初にどちらを左手用/右手用にするか決めます。  

赤丸で示した、PCBが欠けている部分にトラックボールがつきます。  
右手親指でトラックボールを操作するなら下写真のような配置になります。  

![20](images/yw020.jpg)

左手でトラックボールを操作する場合は下写真のような配置です。 

![21](images/yw021.jpg)

本ビルドガイドでは右手にトラックボールをつける仕様で説明します。  
下記のようにPCBを置き、ミス防止のため表面にマスキングテープを貼ります。

![22](images/yw022.jpg)

<a id="anchor3-1"></a>
### 3-1．はんだ付けの前に
半田ごての”こて先”は竹槍の先端のような形状のものだと平面にはんだを乗せたり、余分なはんだを”すくい取る”事が出来るので使いやすいです。

![27](images/yw027.jpg)

<a id="anchor3-2"></a>
### 3-2．ダイオードの取り付け
それではダイオードを順にはんだ付けしていきます。  
ダイオードはすべて【裏面】にはんだ付けします。  
  
ダイオードのシルクマークは下写真の矢印のようなマークで、左右合計で48個あります。  
ダイオードには極性がありますので、正しい向きで取り付けてください。向きは部品上の直線とシルクマークの矢印の先についている直線が一致する方向です。  
  
下写真をよく見て向きを確認してください。  
同一基板上のダイオードの向きは90度回転して配置されているダイオードを除き、すべて同じ向きで配置されています。半田付けを進める中で回りのダイオードと同じ向きになっているか確認しながら行ってください。

![25](images/yw025.jpg)

キットには含まれませんが、リードタイプのダイオードも取付けられるように設計されています。（ただしロープロファイル(choc)仕様で組み立てる場合、トッププレートと干渉するためリードタイプは使用できません）  
  
表面実装タイプのダイオードは、慣れてくると早く作業ができますが、ピンセットで挟んだ状態で基板上に静止させる必要があり、確かに難易度が高いです。どちらでもお好みのタイプをご使用ください。  
  
リードタイプを使用する場合、極性は下記のように部品に記された帯マークとシルクマークの直線が同じ向きを向くように付けます。

![26](images/yw026.jpg)

それでは半田付け開始です。まず、ダイオード用パッドの片側にはんだを盛ります。

![28](images/yw028.jpg)

ピンセットでダイオードを掴み、事前に盛ったはんだを溶かしながらダイオードを固定します。

![30](images/yw030.jpg)

基板を180度回転させてダイオードの反対側の足へもはんだを流します。
最後に両方の足をこて先で触り、ダイオードが脱落しなければ両足とも半田付けされています。

![31](images/yw031.jpg)

リードタイプのダイオードを使用する場合には、シルクの一つ外側のスルーホールに足を通します。

![32](images/yw032.jpg)

リードタイプのはんだ付けは表面から行います。

![33](images/yw033.jpg)

はんだ付けしたら余計な足をカットします。  
表面にはんだの盛り上がりが残るため、ロープロファイル(choc)仕様で組み立てる場合にはリードタイプは使用できません。  
また親指キーのみロープロファイルにする場合には、親指キーだけは表面実装タイプをはんだ付けしてください。

![34](images/yw034.jpg)

右手基板には２４個のダイオードを取り付けます。

![37](images/yw037.jpg)

左手基板へも同様に作業します。こちらも２４個取り付けます。  
私もよく取付忘れや片側だけはんだ付けされていなかったということがありますので、数を数えてご確認ください。

![38](images/yw038.jpg)

<a id="anchor3-3"></a>
### 3-3．ジャンパのはんだ付け
OLEDモジュールとトラックボールセンサを動作させるためにジャンパをショートさせる必要があります。  j
ジャンパは__【裏面のみ】__に行います。  
"Back Side Only"の表示があり、右手基板には計【８個】あります。  
パッドをこて先で温めてはんだを溶かすとブリッジできます。

![40](images/yw040.jpg)

はんだの鮮度が落ちると表面張力が落ちてうまくブリッジできません。  
一度はんだを払ってしまい、はんだやフラックスを足してやり直してください。

![41](images/yw041.jpg)

左手基板もジャンパするのは【裏面のみ】です。  
【４個】ジャンパします。  
左手基板にはこの４個以外にもジャンパパッドがありますが、これらは現状使用しませんのではんだ付けの必要はありません。

![42](images/yw042.jpg)

<a id="anchor3-4"></a>
### 3-4．4連ピンソケット・TRRSソケット・タクトスイッチ
下記写真の部品をのはんだ付けします。  
すべて【表面】に取付けます。  

![51](images/yw051.jpg)

部品が浮いてしまうのが心配であれば、マスキングテープで固定してはんだ付けします。

![52](images/yw052.jpg)



![53](images/yw053.jpg)

<a id="anchor3-5"></a>
### 3-5．ProMicroのはんだ付け
ProMicroは下記写真のコンスルーピンを使用してはんだ付けすることで、交換が可能になります。コンスルーピンには取付け方向がありますので写真をよく見て作業してください。

![60](images/yw060.jpg)

まずコンスルーピンを右手基板に差し込みます。

![61](images/yw061.jpg)

差し込んだコンスルーピンにProMicroを挿入します。  
この状態でProMicro側のみはんだ付けします。

![63](images/yw063.jpg)

基板に差し込んだ状態ではんだ付けすることで、コンスルーピンが斜めに取り付けられてしまうことを防げます。

![64](images/yw064.jpg)

左手基板も同様にはんだ付けします。

![65](images/yw065.jpg)

左手基板には標準でOLEDが搭載できます。  
4連ピンソケットに4連ピンヘッダを挿入してOLEDモジュールを載せます。

![70](images/yw070.jpg)

4ピンのうちのひとつだけをはんだ付けします。  
そのはんだを溶かしながらOLEDモジュールを上から押して浮かないようにします。またProMicroと並行になるように調整すると見栄えが良くなります。


![71](images/yw071.jpg)

位置が決まったら残り3ピンをはんだ付けします。

![72](images/yw072.jpg)

<a id="anchor3-6"></a>
### 3-6．ProMicoの書き込みと動作確認
それではまずテスト用のファームウェアをProMicroに書き込みましょう。  

テスト用ファームウェアは動作確認しやすいようにキーマップが簡潔なのと、RGB LEDが赤→緑→青と順に点灯するため、はんだ不良を発見しやすいです。
今回はLEDはんだ付けを見送っている場合など、テスト用ファームウェアが必要無いと思われる方は[１０章](#１０正規ファームウェアの書き込み)の正規のファームウェアをここで書き込んでも構いません。  
  

Keyball46のファームウェアは、トラックボールを右手と左手のどちらに載せたかで種類が分かれます。下記の適切な方のリンクからzipファイルをダウンロードして解凍し、QMK_ToolBoxで書き込んでください。  
   - トラックボールを右手側につけた方はこちらの[keyball_test_1.0.0.zip](https://github.com/Yowkees/keyball/files/6809109/keyball_test_1.0.0.zip)をダウンロード
   - トラックボールを左手側につけた方はこちらの[keyball_test_Left_1.0.0.zip](https://github.com/Yowkees/keyball/files/6809113/keyball_test_Left_1.0.0.zip)をダウンロード

zipファイルを解凍すると中には２つのhexファイルが入っています。Keyball46では左右に別々のファームウェアを書き込みます。
   - keyball_rev1_ball_test.hex　←この"ball"が名前に含まれている方はトラックボールありの基板に書き込みます
   - keyball_rev1_noball_test.hex　←この"noball"が名前に含まれている方はトラックボール無しの基板に書き込みます

書き込みはQMK Toolboxを使用して書き込んでください。QMK Toolboxについては [Corneのファームウェア](https://github.com/foostan/crkbd/blob/master/doc/firmware_jp.md) の記事を参照してください。  

書き込みが完了したら下写真のようにキースイッチのパッドをピンセットでショートして動作確認します。  
早い段階で動作確認をすることで問題の切り分けが楽になります。

![75](images/yw075.jpg)

テキストエディタに文字が入力されることを確認します。  
※~~Keyball46が完成したら、USBケーブルはトラックボールを取り付けた側に接続して使用します。そうしないとトラックボールが機能しません。~~ 最新のファームウェアでは左右どちらにUSBケーブルを接続してもトラックボールが機能します！  


![76](images/yw076.jpg)

<a id="anchor3-7"></a>
### 3-7．アンダーグロー用LED（オプション）のはんだ付け
LED（YS-SK6812MINI-E）はオプションになります。左右で計14個取り付け可能です。  
ただしLEDは非常に熱に弱く、こて先温度を220度～280度に調整して行ってください。  
こて先温度が低いためパッドに熱が伝わらずテンプラしやすいです。  
LED無しでもキーボードは使用できますし、難易度が高いのでまずはLEDなしで完成させることをおすすめします。後からでもLEDを追加できます。  
  
YS-SK6812MINI-Eの４ピンのうち切り欠きがある足と、マーキングされているパッドを合わせます。

![80](images/yw080.jpg)

下写真のような状態ではんだ付けします。  
一度に４ピンすべてのはんだ付けをすると部品の温度が上がり壊れやすいので、２ピンづつくらいで時間をあけてはんだ付けしてください。

![81](images/yw081.jpg)

はんだ付けが完了したら点灯を確認します。  
LEDは直列に配線されているので、途中までしか点灯しない場合はそのLEDとその両隣のLEDのはんだ付けや、LEDを交換して修正してください。  
７つすべて点灯すると下写真のようになります。  
  
また、青丸部のようにはんだカスが基板や別のパッドについた場合、こて先の温度が低いと除去しにくいので、気にせず作業を進め、こて先温度を上げた後で撫でれば簡単に除去できます。

![82](images/yw082.jpg)

<a id="anchor3-8"></a>
### 3-8．キーソケットのはんだ付け
キーソケットをシルクマークと形状が合うようにセットしてはんだ付けします。  
シルクからはみ出すようであれば方向が違います。

![85](images/yw085.jpg)

青丸で示すように事前にソケットようパッドにはんだを盛っておきます。

![86](images/yw086.jpg)

ソケットをはめて上からピンセットで抑えて端子の横からはんだを少し載せたこて先を当てると、はんだが溶けてソケットが沈み込みます。  
経験上、この方法が一番テンプラ（接続不良）しにくいです。  

基板を180度回転させて反対側の端子も同様にはんだ付けします。

![87](images/yw087.jpg)

ロープロファイルソケット（kailh choc）を使用する場合は下写真のようになります。

![88](images/yw088.jpg)

左右合わせて46個はんだ付けして完了です。

![89](images/yw089.jpg)

<a id="anchor4"></a>
## ４．ボール読み取り基板の組み立て
下写真の基板（以下、ボール基板）とセンサーを準備します。
※センサーや基板の品質確認のため、はんだ付け済の基板が届く場合があります。その時にはこの工程は飛ばして、5-2章のL字コンスルーはんだ付けに進んでください。

![90](images/yw090.jpg)  

<a id="anchor4-1"></a>
## 4-1．センサーのはんだ付け  

センサーICはボール基板の部品が実装されていない裏面から差し込みます。  
ICの１ピンを示すくぼみと基板のパッドマークを合わせます。

![91](images/yw091.jpg)

ICを裏から見るとこのような方向です。部品が実装されている表面から全ピンをはんだ付けしてください。

![92](images/yw092.jpg)

ピンセットを使って保護シール【２枚】をはがします。

![93](images/yw093.jpg)

シールをはがした面にセンサーレンズを取付けます。

![94](images/yw094.jpg)

レンズには方向があります。  
レンズ手前に下写真矢印のような突起があり、これが上側にくるように取り付けます。

![95](images/yw095.jpg)

<a id="anchor4-2"></a>
### 4-2．L字コンスルーのはんだ付け
次にL字コンスルーピンを右手基板【表面】に取付けます。  
L字コンスルーにも方向があり、下写真と同じように取り付けてください。  
ピンがU字型になっていない方をはんだ付けします。

![96](images/yw096.jpg)

部品が浮かないようにマスキングテープを貼ってはんだ付けしてください。

![97](images/yw097.jpg)

<a id="anchor5"></a>
## ５．左手側の左右判定ジャンパーをはんだ付け 

Keyball46の標準ファームウェアには左右自動判定機能がついています。判定のために【左手側の基板だけ】に１個所ジャンパーをはんだ付けします。  

左手側基板を裏から見ると下写真赤丸部に[SW]というシルクがあります。これをお手持ちのリード線端材か銅線、使用せずに余ったピンヘッダのピンを一本ペンチで引き抜いたものなどでジャンパーしてください。

![140](images/yw140.jpg)

左利き用で組み立てている場合も【左手側の基板だけ】にジャンパーします。左手仕様の場合は下写真赤丸部に[SW]があります。（基板の生産ロットにより少し[SW]の位置や傾きが違う場合があります）

![141](images/yw141.jpg)

ロープロファイル(kailh choc)仕様で組み立てる場合、基板の表面にはんだがはみ出すとトッププレートと干渉してしまいます。  
リード線でジャンパーする場合、下写真のようにあらかじめ足を短く切っておきます。
![142](images/yw142.jpg)

それを下写真のようにスルーホールにはめて裏面からはんだ付けすれば表面にはんだが飛び出しにくくなります。飛び出ている場合には表面からはんだをすくい取ってください。
![143](images/yw143.jpg)

以上ではんだ付け作業は完了です。

余談ですがはんだごての電気を落とす前に、こて先にたっっぷりとはんどを付けておきましょう。次回使用するときにこのはんだを落とせば、ピカピカのこて先で作業を再開できますよ！

![100](images/yw100.jpg)

<a id="anchor6"></a>
## ６．トッププレートのカット（オプション）  

Keyball46は親指キーのみロープロファイルにすることが可能です。  
そのためにはミシン目をカットします。  
高さを変える必要がない場合は切り取る必要はありません。  
  
切り取るには大き目のニッパでミシン目に傷をつけます。  

![101](images/yw101.jpg)

カッターで少しづつ切り込みを増やしていくと切り離すことができます。

![102](images/yw102.jpg)

左右両方とも切り離すことができました。

![103](images/yw103.jpg)


150番くらいのやすりでバリを取ります。

![104](images/yw104.jpg)

<a id="anchor7"></a>
## ７．組み立て 

<a id="anchor7-1"></a>
### 7-1.保護プレートの取り付け  

ミドル基板にProMicro保護プレートを取り付けます。
まず9mmスペーサをねじ止めします。

![110](images/yw110.jpg)

アクリル保護プレートをねじ止めします。右手はスペーサ３つ、左手はスペーサ２つで固定します。

![111](images/yw111.jpg)  

<a id="anchor7-2"></a>
### 7-2.トッププレートの組み立て  

トッププレートの【裏面】に7mmスペーサ（ロープロファイル仕様なら4mmスペーサ）をねじ止めします。

![112](images/yw112.jpg)

トッププレートの四隅にキースイッチをはめ込みます。こうするとプレート同士の位置決め精度が上がります。

![113](images/yw113.jpg)

トッププレートとミドルプレートのねじ穴を合わせ、キースイッチの端子がしっかりキーソケットに入ることを確認しながらプレート同士を重ねます。

![114](images/yw114.jpg)

<a id="anchor7-3"></a>
### 7-3.ボトムプレートの組み立て  

裏面からアクリルボトムプレートを重ねてねじ止めします。ねじは左右とも７本です。

![115](images/yw115.jpg)

<a id="anchor8"></a>
## ８．トラックボール取り付け 

<a id="anchor8-1"></a>
### 8-1.ボール読み取り基板差し込み  

組み立てたトラックボール読み取り基板を７ピンコンスルーへ差し込みます。わかりやすいように斜めにしていますが、基板は垂直にして差し込みます。

![120](images/yw120.jpg)

ボール基板が垂直に立ちました。

![121](images/yw121.jpg)

<a id="anchor8-2"></a>
### 8-2.トラックボールケースの組み立て  

トラックボールケースには事前にセラミックボール3個が固定されています。万が一セラミックボールが脱落している場合にはお手数ですが予備のセラミックボールを適当なボンドで固定してください。  
セラミックボールの予備は今後ボールを紛失した時のために保管しておいてください。

![122](images/yw017.jpg)

ケース下の穴へ、ケース上のピン２本が挿入できます。  
上下からゆっくり力を入れて結合します。（ぴったりと結合しなくてもこの後のねじ絞めでくっつきますので大丈夫です。）

![123](images/yw123.jpg)

M1.7のトルクスねじをつけます。キットにはねじ頭が【小さいねじ】と【平らなねじ】が同梱されていますが、そのうちの【頭の小さいねじ】を使用します。

![124](images/yw124.jpg)

ケース裏から見て、この２個所をねじ止めします。締め付けすぎにご注意ください。

![125](images/yw125.jpg)

<a id="anchor8-3"></a>
### 8-3.トラックボールケース装着  

完成したケースを本体に取付けます。ケース裏側のセンサー収納部にボール基板が入ります。  
矢印で示すボール基板がケース中央くらいにくるようにしながら、上からゆっくりとはめます。引っ掛かりがある場合、無理に押し込まず、一度引き抜いて再度入れ直してください。

![126](images/yw126.jpg)

それほど力を入れなくても最後まで入るはずです。

![127](images/yw127.jpg)

本体裏から確認するとメイン基板とボール基板の間に、矢印で示すような隙間が出来ている場合があります。

![128](images/yw128.jpg)

その時は、軽～くケース手前（指マークの方向）から押します。力を入れすぎるとL字コンスルーが破損する可能性があるので、軽く押してください。  
下写真のように隙間がなくなれば、青丸部のねじ穴が合うと思います。

![129](images/yw129.jpg)

キットに同梱のM1.7トルクスねじの【頭が平らなねじ】２本を本体裏から絞めます。この時ボール保持ケースが回転しないように指で抑えながらねじを絞めてください。

![130](images/yw130.jpg)

<a id="anchor9"></a>
## ９．総仕上げ 

完成間近です！お好みのキースイッチをはめ込んでいきます。

![131](images/yw131.jpg)

最後に34mmトラックボールをケースに押し込んで完成です！  
お疲れ様でした。  

![132](images/yw132.jpg)

<a id="anchor10"></a>
## １０．正規ファームウェアの書き込み 

それでは最後に正規のファームウェアをProMicroに書き込みましょう。Keyball46は[Remap](https://remap-keys.app/configure)に対応していますのでビルド環境がなくてもキーマップの変更が可能です。Remapの使用方法については[自キ温泉ガイドのサリチル酸](https://salicylic-acid3.hatenablog.com/entry/remap-manual)の記事に詳しく掲載されています。  

テストファームウェア書き込みの章にも書きましたが、Keyball46のファームウェアは、トラックボールを右手と左手のどちらに載せたかで種類が分かれます。下記の適切な方のリンクからzipファイルをダウンロードしてください。
   - トラックボールを右手側につけた方はこちらの[keyball_via_1.0.0.zip](https://github.com/Yowkees/keyball/files/6809101/keyball_via_1.0.0.zip)をダウンロード
   - トラックボールを左手側につけた方はこちらの[keyball_via_Left_1.0.0.zip](https://github.com/Yowkees/keyball/files/6809107/keyball_via_Left_1.0.0.zip)をダウンロード

zipファイルを解凍すると中には２つのhexファイルが入っています。Keyball46では左右に別々のファームウェアを書き込みます。
   - keyball_rev1_ball_via.hex　←この"ball"が名前に含まれている方はトラックボールありの基板に書き込みます
   - keyball_rev1_noball_via.hex　←この"noball"が名前に含まれている方はトラックボール無しの基板に書き込みます

書き込みはQMK Toolboxを使用して書き込んでください。

■ご自身でファームウェアをビルドする場合  
Keyball46の最新ファームウェアは[Githubのリポジトリ](https://github.com/Yowkees/keyball/tree/main/qmk_firmware/keyboards/keyball)にて公開しています。このkeyballフォルダをお手持ちのQMK_Firmware/keyboardsへコピーして自由にキーマップ等を編集してmakeしてください。  

<a id="anchor11"></a>
## １１．Keyballの使い方♪ 
   - トラックボールはレイヤー３に切り替わっている間は上下左右スクロールに変わります
   - [Remap](https://remap-keys.app/configure)に対応していますので、簡単にキーマップの確認・変更・書込みが可能です
   - USBケーブルは左右どちらに差しても使用できます。ただしキーマップはUSBケーブルを差した側のProMicroへ書き込まれるため、初めて差し替えた場合にはキーマップを見直してください


以上でKeyball46のビルドガイドは終了です。
Keyball46についてのご質問や不具合等についてはGithubのリポジトリ、[Yowkees/keyballのDiscussions](https://github.com/Yowkees/keyball/discussions)へご投稿ください。なるべく早くご回答させていただきます。

―あとがき―  
Keyball46の回路設計者は、トラックボール付きキーボード！に加えてRGB LEDにOLED、VIAにも対応したいし、今後タッチパッドや1Uトラックボールを拡張できるようにしたいと、実に盛りだくさんなキーボードキットを設計してしまいました。ProMicroの容量制限やトラックボール動作等に不安があったファームウェアを、KoRoN@香り屋様をはじめ多くの方のご協力により大幅に改善・安定化できました。また左右自動判別機能やトラックボール情報の左右間通信等、将来的にできたらという技術まで確立できたことで、左右両方にトラックボールを搭載することも可能となってきました。この場をお借りしてお礼申し上げます。本当にありがとうございました　@Yowkees
